package com.steerinfo.baseinfo.appversionmsg.controller;

import com.steerinfo.baseinfo.appversionmsg.mapper.AppVersionMsgMapper;
import com.steerinfo.baseinfo.appversionmsg.model.AppVersionMsg;
import com.steerinfo.baseinfo.appversionmsg.service.IAppVersionMsgService;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.user.UserPayload;
import com.steerinfo.framework.utils.collection.ListUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

/**
 * AppVersionMsg RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-04-09 11:53
 * 类描述
 * 修订历史：
 * 日期：2022-04-09
 * 作者：generator
 * 参考：
 * 描述：AppVersionMsg RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/appversionmsgs")
public class AppVersionMsgController extends BaseRESTfulController {

    @Resource
    AppVersionMsgMapper appVersionMsgMapper;

    @Autowired
    IAppVersionMsgService appVersionMsgService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("appversionmsg:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<AppVersionMsg> list = appVersionMsgService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("appversionmsg:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<AppVersionMsg> list = appVersionMsgService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据AppVersionMsg对象创建")
    @ApiImplicitParam(name = "appVersionMsg", value = "详细实体appVersionMsg", required = true, dataType = "AppVersionMsg")
    //@RequiresPermissions("appversionmsg:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody AppVersionMsg model){
        model.setVersionId(appVersionMsgMapper.getNewId());
        UserPayload payload = UserPayload.getCurrUser();
        model.setCreateId(payload.getUserCode());
        model.setCreateName(payload.getUserName());
        model.setCreateTime(new Date());
        model.setPublishUserId(payload.getUserCode());
        model.setPublishUserName(payload.getUserName());
        model.setPublishDate(new Date());
        AppVersionMsg appVersionMsg = appVersionMsgService.add(model);
        return success(appVersionMsg);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("appversionmsg:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        AppVersionMsg appVersionMsg = appVersionMsgService.getById(id);
        return success(appVersionMsg);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的appVersionMsg信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "appVersionMsg", value = "详细实体appVersionMsg", required = true, dataType = "AppVersionMsg")
    })
    //@RequiresPermissions("appversionmsg:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody AppVersionMsg model){
        model.setId(id);
        UserPayload payload = UserPayload.getCurrUser();
        model.setUpdateId(payload.getUserCode());
        model.setUpdateName(payload.getUserName());
        model.setUpdateTime(new Date());
        AppVersionMsg appVersionMsg = appVersionMsgService.modify(model);
        return success(appVersionMsg);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("appversionmsg:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  appVersionMsgService.delete(ids);
    	}
      return success();
    }


    /*@ApiOperation(value="创建", notes="根据AppVersionMsg对象创建")
    @PostMapping(value = "/addModel")
    public RESTfulResult addModel(@RequestBody HashMap params){
        RESTfulResult rm = failed();

        rm = appVersionMsgService.addModel(params);
        return success(rm);
    }*/
}
